#include "level.h"

int H3Level::Load(int lv,H3Monster *hm,const char* levname)
{
 ifstream is;
 char st[256];
 int co=0,pagnum=0;
 pages= 2;

 is.open(levname);
 if (is.bad() || is.fail()) return 1;

 for (;!is.eof();)
 {
  is >> st;
  if (st[0]== '#')
   for (char a= 0;a!= '\n' && !is.eof();) a=is.get();

  if (is.bad()) return 1;

  if (!stricmp(st,"LEVEL"))
   {
    if (pages==pagnum+1)
     {
      is.close();
      return 0;
     }
    is >> st;
    levnum= atoi(st);
    if (levnum== lv) lv= 0;
    is >> st;
    pages= atoi(st);
   }
  if (lv==0 && !stricmp(st,"PAGE"))
   { is >> st;
    pagnum= atoi(st);
    pagnum--;
   }
  if (lv==0 && !stricmp(st,"LEFT"))
   { is >> st;
    pag[pagnum].left= atoi(st);
   }
  if (lv==0 && !stricmp(st,"RIGHT"))
   { is >> st;
    pag[pagnum].right= atoi(st);
   }
  if (lv==0 && !stricmp(st,"UP"))
   { is >> st;
    pag[pagnum].up= atoi(st);
   }
  if (lv==0 && !stricmp(st,"DOWN"))
   { is >> st;
    pag[pagnum].down= atoi(st);
   }
  if (lv==0 && !stricmp(st,"TEL1"))
   { is >> st;
    pag[pagnum].tel1= atoi(st);
   }
  if (lv==0 && !stricmp(st,"TEL2"))
   { is >> st;
    pag[pagnum].tel2= atoi(st);
   }
  if (lv==0 && !stricmp(st,"BACKGROUND"))
   { is >> st;
    pag[pagnum].bckgrd= atoi(st);
   }
  if (lv==0 && !stricmp(st,"START"))
   {
    is >> st;
    hm[0].SetX(atoi(st)*10);
    is >> st;
    int _y= atoi(st);
    if (_y==0) hm[0].SetY(6);
       else hm[0].SetY(_y*50+6);
    hm[0].SetID(0);
    hm[0].SetType(TYPE_HROCH);
   }
  if (lv==0 && !stricmp(st,"MONSTER"))
   {
    int i;
    for (i= 1;i<MAX_MONSTERS;i++)
      if (hm[i].GetID()== -1) break;
    is >> st;
    hm[i].SetType(atoi(st));
    is >> st;
    hm[i].SetID(atoi(st));
    is >> st;
    hm[i].SetX(atoi(st)*10);
    is >> st;
    int _y= atoi(st);
    int py=0;
    switch (hm[i].GetType())
     {
      case TYPE_SNEK : py= 32; break;
     }
    if (_y==0) hm[i].SetY(py);
       else hm[i].SetY(_y*50+py);
    hm[i].SetPage(pagnum);
   }
  if (lv==0 && !stricmp(st,"DATA"))
   {
    for (;is.get()!= '\n';) if (is.eof()) return 0;
    char a= '\0';
    for (int y= 0;y< 10;y++)
     {
      for (int x= 0;x<=64;x++)
       {
        if (a!= '\n') a= is.get();
        if (is.eof()) return 0;
        if (a!= '\n') pag[pagnum].chrs[x][y]= a;
          else pag[pagnum].chrs[x][y]= '\0';
         }
      a= '\0';
     }
   }
 }
 return 0;
}

int H3Level::MakeBitmap(int page,BITMAP* bm,H3Frames *hf,H3Monster *hm,char *hacka,int curpage,FONT *fo)
{
 char next[128];
 memset(next,0,sizeof(next));

 BITMAP* pom= create_bitmap(640,480);

 int he,wi,px=0,py=0;
 int maluj;
 int vypis= FALSE;

 for (int k= 0;k<=20;k++) line(bm,0,k,300,k,makecol(255-k*10,255-k*10,255-k*10));
// for (int k= 0;k<=20;k++) line(bm,0,k,90,k,makecol(k*10,k*10,k*10));
 for (int j= 1;j<=hm[0].GetLives();j++)
  {
   if (next['z']== 0)
    { hf[3].GetNext(pom); next['z']= 1;
    } else hf[3].GetThis(pom);
   masked_blit(pom,bm,0,0,j*20,3,10,12);
  }
 for (int j= 0;j<10;j++)
  {
   if (hacka[j]!=0) {
    if (next['0']== 0)
     { hf[4].GetNext(pom); next['0']= 1;
     } else hf[4].GetThis(pom);
    } else
     {
      rectfill(pom,0,0,10,12,makecol(255,0,255));
      circle(pom,5,6,4,makecol(255,255,0));
     }
   masked_blit(pom,bm,0,0,j*20+100,3,10,12);
  }


 for (int y= 0;y<10;y++)
  for (int x= 0;x<=64;x++)
   {
    maluj= FALSE;
    switch (pag[page].chrs[x][y])
     {
      case 'A' : if (next['A']==0)
                  {
                   hf[0].GetNext(pom); next['A']= 1;
                  } else hf[0].GetThis(pom);
                 he= 20; wi= 10; maluj= TRUE; break;
      case 'B' : if (next['B']== 0)
                  {
                   hf[1].GetNext(pom); next['B']= 1;
                  } else hf[1].GetThis(pom);
                  he= 20; wi= 10; maluj= TRUE; break;
      case 'C' : if (next['C']== 0)
                  {
                   hf[7].GetNext(pom); next['C']= 1;
                  } else hf[7].GetThis(pom);
                  he= 20; wi= 10; maluj= TRUE; break;
      case 'D' : if (next['D']== 0)
                  {
                   hf[8].GetNext(pom); next['D']= 1;
                  } else hf[8].GetThis(pom);
                  he= 20; wi= 10; maluj= TRUE; break;
      case 'E' : if (next['E']== 0)
                  {
                   hf[9].GetNext(pom); next['E']= 1;
                  } else hf[9].GetThis(pom);
                  he= 20; wi= 10; maluj= TRUE; break;
      case 'F' : if (next['F']== 0)
                  {
                   hf[10].GetNext(pom); next['F']= 1;
                  } else hf[10].GetThis(pom);
                  he= 20; wi= 10; maluj= TRUE; break;
      case 'a' : if (next['a']== 0)
                  {
                   hf[2].GetNext(pom); next['a']= 1;
                  } else hf[2].GetThis(pom);
                  he= 80; wi= 30; maluj= TRUE; break;
      case 'z' : if (next['z']== 0)
                  {
                   hf[3].GetNext(pom); next['z']= 1;
                  } else hf[3].GetThis(pom);
                  he= 12; wi= 10; py= 40;maluj= TRUE; break;
      case 'b' : if (next['b']== 0)
                  {
                   hf[5].GetNext(pom); next['b']= 1;
                  } else hf[5].GetThis(pom);
                  he= 36; wi= 15; py= 10;maluj= TRUE; break;
      case '<' : if (next['<']== 0)
                  {
                   hf[6].GetNext(pom); next['<']= 1;
                  } else hf[6].GetThis(pom);
                  he= 48; wi= 32; py= 32;maluj= TRUE; break;
      case '>' : if (next['>']== 0)
                  {
                   hf[6].GetNext(pom); next['>']= 1;
                  } else hf[6].GetThis(pom);
                  he= 48; wi= 32; py= 32;maluj= TRUE; break;
      case '0' : case '1' : case '2' : case '3' : case '4' :
      case '5' : case '6' : case '7' : case '8' : case '9' :
                 if (next['0']== 0)
                  {
                   hf[4].GetNext(pom); next['0']= 1;
                  } else hf[4].GetThis(pom);
                  he= 12; wi= 10; py= 40;maluj= TRUE; break;
      case '\x10':case '\x1' : case '\x2' : case '\x3' : case '\x4' :
      case '\x5': case '\x6' : case '\x7' : case '\x8' : case '\x9' :
                 if (hacka[pag[page].chrs[x][y]-1]== 1)
                  {
                    if (next['A']==0 )
                    {
                     hf[0].GetNext(pom); next['A']= 1;
                    } else hf[0].GetThis(pom);
                    he= 20; wi= 10; maluj= TRUE;
                  } else
                  {
                   char zpr[256];
                   sprintf(zpr,"You need key number %i !",pag[page].chrs[x][y]);
                   if (!vypis) textout(bm,fo,zpr,350,0,makecol(255,0,0));
                   vypis= TRUE;
                  } break;
     }
    if (maluj)
     {
      if (y % 2== 0)
       {
        if (y==0) masked_blit(pom,bm,0,40,x*10+px,0+py,wi,he/2);
           else masked_blit(pom,bm,0,0,x*10+px,y*50-20+py,wi,he);
       }
             else masked_blit(pom,bm,0,0,x*10+px,y*50+10+py,wi,he);
       px= 0;
       py= 0;
     }

   }
 for (int i= 0;i<MAX_MONSTERS;i++)
  {
   if ((hm[i].GetID()!= -1 && hm[i].GetPage()== curpage) || i==0)
    {
     hm[i].GetNext(pom);
     masked_blit(pom,bm,0,0,hm[i].GetX(),hm[i].GetY(),hm[i].GetW(),hm[i].GetH());
    }
  }

 destroy_bitmap(pom);
}

// H3Frames

void H3Frames::GetNext(BITMAP* bm)
{
 curbmp++;
 if (curbmp>bmpcnt) curbmp= 0;
 blit(bmps[curbmp],bm,0,0,0,0,bmps[curbmp]->w,bmps[curbmp]->h);
}

void H3Frames::GetThis(BITMAP* bm)
{
 blit(bmps[curbmp],bm,0,0,0,0,bmps[curbmp]->w,bmps[curbmp]->h);
}

int H3Frames::Load(int num,int x,int y,int line,char* filename,RGB* pal)
{
 BITMAP* bm= load_bitmap(filename,pal);//create_bitmap(640,480);
 //bm=

 if (!bm) return FALSE;

 for (int i= 0;i<=num;i++)
  {
   bmps[i]= create_bitmap(x,y);
   blit(bm,bmps[i],i*x+i+1,line,0,0,x,y);
//   masked_blit(bmps[i],screen,0,0,0,0,x,y); // kontrola
//   readkey();
  }
 curbmp= 0;
 bmpcnt= num;
 destroy_bitmap(bm);
 return TRUE;
}

H3Frames::~H3Frames()
{
 for (int i= 0;i<=bmpcnt;i++) destroy_bitmap(bmps[i]);
}

// H3Monster

void H3Monster::GetNext(BITMAP* bm)
{
 blit(bmps[curbmp],bm,0,0,0,0,bmps[curbmp]->w,bmps[curbmp]->h);
// char pom[16];
// textout(bm,font,itoa(curbmp,pom,10),0,0,makecol(255,0,0));
// masked_blit(bm,screen,0,0,0,0,bm->w,bm->h);
// if (readkey() >> 8== KEY_ESC) exit(1);
 if (!acplok)
  {
   switch (acpl)
   {
    case STEP_RIGHT : x+=10; break;
    case STEP_LEFT : x-=10; break;
   }
   acplok= TRUE;
  }
 if (action!= NO_ACTION)
 {
   curbmp++;
   switch (action)
   {
     case STEP_RIGHT :
        if (type== TYPE_HROCH) x+= 5;
        else if (type== TYPE_SNEK) x+= 2; break;
     case STEP_LEFT :
        if (type== TYPE_HROCH) x-= 5;
        else if (type== TYPE_SNEK) x-= 2; break;
     case JUMP_UP : y-= 20; break;
     case JUMP_DOWN : y+= 20; break;
     case SWIM : x+= 5; break;
   }
   if (curbmp>=stend[action][1])
    {
     switch (action)
     {
       case STEP_RIGHT :
        if (type== TYPE_HROCH) x+= 2;
        else if (type== TYPE_SNEK) x+= 1; break;
       case STEP_LEFT :
        if (type== TYPE_HROCH) x-= 2;
        else if (type== TYPE_SNEK) x-= 1; break;
       case JUMP_UP : y-= 20; break;
       case JUMP_DOWN : y+= 20; break;
       case SWIM : x+= 5; break;
     }
     curbmp= stend[action][0];
     prevac= action;
     action= NO_ACTION;
    }
 }
}

void H3Monster::GetThis(BITMAP* bm)
{
 blit(bmps[curbmp],bm,0,0,0,0,bmps[curbmp]->w,bmps[curbmp]->h);
// masked_blit(bm,screen,0,0,0,0,bm->w,bm->h);
// if (readkey() >> 8== KEY_ESC) exit(1);
}

int H3Monster::Load(int num,int x,int y,int line,char* filename,RGB* pal)
{
 BITMAP* bm= load_bitmap(filename,pal);//create_bitmap(640,480);
// bm= load_bitmap(filename,pal);

 if (!bm) return FALSE;

 int j=0;

 for (int i= 0;i<=num;i++)
  {
   if (j*x+j+1+x>640)
    {
     line+= y;
     line+= 1;
     j= 0;
    }
   bmps[i]= create_bitmap(x,y);
   blit(bm,bmps[i],j*x+j+1,line,0,0,x,y);
//   masked_blit(bmps[i],screen,0,0,j*x+j+1,line,x,y); // kontrola
   j++;
//   readkey();         // kontrola
  }
 curbmp= 0;
 bmpcnt= num;
 wi= x;
 he= y;
 destroy_bitmap(bm);
 return TRUE;
}

H3Monster::~H3Monster()
{
 for (int i= 0;i<=bmpcnt;i++) destroy_bitmap(bmps[i]);
}

void H3Monster::SetAction(int ac)
{
 action= ac;
 curbmp= stend[action][0];
}
void H3Monster::SetStEnd(const char se[10][2])
{
 memcpy(stend,se,sizeof(stend));
}
int H3Monster::ActionOK()
{
 if (action== NO_ACTION) return TRUE;
 if (curbmp== stend[action][1]) return TRUE;
    else return FALSE;
}
void H3Monster::SetCurBmp(int cb)
{
 curbmp= cb;
}

