#ifndef __H3_LEVEL_H__
#define __H3_LEVEL_H__

#include <stdio.h>
#include <string.h>
#include <allegro.h>
#include <fstream.h>

#define MAX_MONSTERS 20

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

// trida na framy

class H3Frames {
private:
 BITMAP* bmps[16];
 int curbmp,bmpcnt;
public:
 H3Frames() {curbmp= 0;bmpcnt= 0;}
 ~H3Frames();
 void GetNext(BITMAP*); // Vrati dalsi frame (kdyz je postedni tak se pretoci)
 void GetThis(BITMAP*);
 int Load(int num,int x,int y,int line,char* filename,RGB* pal); //nacte framy
};

enum {          // konstanty pro akce hrocha, nektere jeste nejsou obsazene
 TURN_LEFT = 0,
 TURN_RIGHT= 1,
 STEP_LEFT = 2,
 STEP_RIGHT= 3,
 JUMP_UP   = 4,
 JUMP_DOWN = 5,
 FIRE_1    = 6,
 FIRE_2    = 7,
 FIRE_3    = 8,
 FIRE_4    = 9,
 DEATH_1   = 10,
 DEATH_2   = 11,
 DEATH_3   = 12,
 TEL_IN    = 13,
 TEL_OUT   = 14,
 SWIM      = 15,
 NO_ACTION = 0xff,

 ACTION_END= 1,
 ACTION_START= 0,
};

enum {          // konstanty pro typ prisery
 TYPE_HROCH = 0,
 TYPE_SNEK = 1,
};

// trochu komplikovanejsi H3Frame

class H3Monster {
private:
 BITMAP* bmps[64];
 int curbmp,bmpcnt,action,acpl,acplok;
 char stend[16][2]; //start,end
 int x,y,ID,lives,type,page,he,wi,prevac;
public:
 H3Monster() {curbmp= 0;bmpcnt= 0;action= NO_ACTION;ID= -1;acplok= TRUE;
              acpl= NO_ACTION;prevac= NO_ACTION;}
 ~H3Monster();
 void GetNext(BITMAP*);
 void GetThis(BITMAP*);
 void SetCurBmp(int );
 void SetAction(int ac);
 void SetPrevAction(int ac) {prevac= ac;}
 void SetActionPlus(int ac) {acpl= ac;acplok= FALSE;}
 void SetStEnd(const char se[13][2]);
 char GetStEnd(int act,int StEnd) {return stend[act][StEnd];}
 int GetAction() {return action;}
 int GetPrevAction() {return prevac;}
 int GetX() {return x;}
 int GetY() {return y;}
 int GetH() {return he;}
 int GetW() {return wi;}
 int GetType() {return type;}
 int GetPage() {return page;}
 void SetX(int _x) {x= _x;}
 void SetY(int _y) {y= _y;}
 void SetH(int _h) {he= _h;}
 void SetW(int _w) {wi= _w;}
 void SetRelX(int _x) {x+= _x;}
 void SetRelY(int _y) {y+= _y;}
 void SetType(int _type) {type= _type;}
 void SetPage(int _page) {page= _page;}

 int ActionOK();
 int ActionPlusOK() {return acplok;}
 int Load(int num,int x,int y,int line,char* filename,RGB* pal);
 int GetID() {return ID;}
 void SetID(int id) {ID= id;}
 int GetLives() {return lives;}
 void SetLives(int l) {lives= l;}
 void SetRelLives(int l) {lives+= l;if (lives<0) lives= 0;}
};

// zde je ulozen level

struct H3Page {
char chrs[65][10];
unsigned char left,right,up,down,tel1,tel2,bckgrd;
};

class H3Level {
private:
 int levnum;
 int pages;
 H3Page pag[100];
public:
 int Load(int ,H3Monster *hm,const char* levname);
 int MakeBitmap(int ,BITMAP* ,H3Frames *hf,H3Monster *hm,char *hacka,int,FONT*);
 unsigned char GetLeft(int page) {return pag[page].left;}
 unsigned char GetRight(int page) {return pag[page].right;}
 unsigned char GetUp(int page) {return pag[page].up;}
 unsigned char GetDown(int page) {return pag[page].down;}
 unsigned char GetTel1(int page) {return pag[page].tel1;}
 unsigned char GetTel2(int page) {return pag[page].tel2;}
 unsigned char GetBackground(int page) {return pag[page].bckgrd;}
 void SetLeft(int page,unsigned char _hod) {pag[page].left= _hod;}
 void SetRight(int page,unsigned char _hod) {pag[page].right= _hod;}
 void SetUp(int page,unsigned char _hod) {pag[page].up= _hod;}
 void SetDown(int page,unsigned char _hod) {pag[page].down= _hod;}
 void SetTel1(int page,unsigned char _hod) {pag[page].tel1= _hod;}
 void SetTel2(int page,unsigned char _hod) {pag[page].tel2= _hod;}
 void SetBackground(int page,unsigned char _hod) {pag[page].bckgrd= _hod;}
 unsigned char GetData(int page,int x,int y)  {return pag[page].chrs[x][y];}
 void SetData(int page,int x,int y,unsigned char data) {pag[page].chrs[x][y]= data;}
 int GetPages() {return pages;}
 int GetLevNum() {return levnum;}
 void SetPages(int pg) {pages= pg;}
 void SetLevNum(int lvn) {levnum= lvn;}
};

#endif
